<?php

namespace Lc\CaracoleBundle\Container\Order;

use Lc\CaracoleBundle\Builder\Order\OrderShopBuilder;
use Lc\CaracoleBundle\Checker\OrderChecker;
use Lc\CaracoleBundle\Factory\Order\OrderShopFactory;
use Lc\CaracoleBundle\Repository\Order\OrderShopRepositoryQuery;
use Lc\CaracoleBundle\Repository\Order\OrderShopStore;
use Lc\CaracoleBundle\Solver\Order\OrderShopSolver;

class OrderShopContainer
{
    protected OrderShopFactory $orderShopFactory;
    protected OrderShopSolver $orderShopSolver;
    protected OrderChecker $orderChecker;
    protected OrderShopRepositoryQuery $orderShopRepositoryQuery;
    protected OrderShopStore $orderShopStore;
    protected OrderShopBuilder $orderShopBuilder;

    public function __construct(
            OrderShopFactory $orderShopFactory,
            OrderShopSolver $orderShopSolver,
            OrderChecker $orderChecker,
            OrderShopRepositoryQuery $orderShopRepositoryQuery,
            OrderShopStore $orderShopStore,
            OrderShopBuilder $orderShopBuilder
    ) {
        $this->orderShopFactory = $orderShopFactory;
        $this->orderShopSolver = $orderShopSolver;
        $this->orderChecker = $orderChecker;
        $this->orderShopRepositoryQuery = $orderShopRepositoryQuery;
        $this->orderShopStore = $orderShopStore;
        $this->orderShopBuilder = $orderShopBuilder;
    }

    public function getFactory(): OrderShopFactory
    {
        return $this->orderShopFactory;
    }

    public function getSolver(): OrderShopSolver
    {
        return $this->orderShopSolver;
    }

    public function getChecker(): OrderChecker
    {
        return $this->orderChecker;
    }

    public function getRepositoryQuery(): OrderShopRepositoryQuery
    {
        return $this->orderShopRepositoryQuery;
    }

    public function getStore(): OrderShopStore
    {
        return $this->orderShopStore;
    }

    public function getBuilder(): OrderShopBuilder
    {
        return $this->orderShopBuilder;
    }

}