<?php

namespace Lc\CaracoleBundle\Container\Section;

use Lc\CaracoleBundle\Factory\Section\SectionFactory;
use Lc\CaracoleBundle\Repository\Section\SectionRepositoryQuery;
use Lc\CaracoleBundle\Repository\Section\SectionStore;
use Lc\CaracoleBundle\Resolver\SectionResolver;

class SectionContainer
{
    protected SectionFactory $factory;
    protected SectionResolver $resolver;
    protected SectionRepositoryQuery $repositoryQuery;
    protected SectionStore $store;

    public function __construct(
            SectionFactory $factory,
            SectionResolver $resolver,
            SectionRepositoryQuery $repositoryQuery,
            SectionStore $store
    ) {
        $this->factory = $factory;
        $this->resolver = $resolver;
        $this->repositoryQuery = $repositoryQuery;
        $this->store = $store;
    }

    public function getFactory(): SectionFactory
    {
        return $this->factory;
    }

    public function getResolver(): SectionResolver
    {
        return $this->resolver;
    }

    public function getRepositoryQuery(): SectionRepositoryQuery
    {
        return $this->repositoryQuery;
    }

    public function getStore(): SectionStore
    {
        return $this->store;
    }

}