<?php

namespace Lc\CaracoleBundle\Factory\Order;

use App\Entity\Order\OrderShop;
use Lc\CaracoleBundle\Event\Order\OrderShopChangeStatusEvent;
use Lc\CaracoleBundle\Factory\SectionFactoryTrait;
use Lc\CaracoleBundle\Model\Merchant\MerchantInterface;
use Lc\CaracoleBundle\Model\Order\OrderShopInterface;
use Lc\CaracoleBundle\Model\Order\OrderStatusModel;
use Lc\CaracoleBundle\Model\Section\SectionInterface;
use Lc\CaracoleBundle\Model\User\VisitorInterface;
use Lc\SovBundle\Factory\AbstractFactory;
use Lc\SovBundle\Model\User\UserInterface;
use Symfony\Component\EventDispatcher\EventDispatcherInterface;

class OrderShopFactory extends AbstractFactory
{
    use SectionFactoryTrait;

    public function create(
            UserInterface $user = null,
            VisitorInterface $visitor = null
    ): OrderShopInterface {

        $orderShop = new OrderShop();

        $orderShop->setSection($this->section);

        $orderShopBelongTo = false;

        if (!is_null($user)) {
            $orderShopBelongTo = true;
            $orderShop->setUser($user);
        }

        if (!is_null($visitor) && !$orderShop->getUser()) {
            $orderShopBelongTo = true;
            $orderShop->setVisitor($visitor);
        }

        if (!$orderShopBelongTo) {
            throw new \ErrorException('La commande doit être liée à un utilisateur ou à un visiteur.');
        }

        return $orderShop;
    }

}
