<?php

namespace Lc\CaracoleBundle\Factory\Product;

use App\Entity\Product\ProductCategory;
use Lc\CaracoleBundle\Factory\MerchantFactoryTrait;
use Lc\CaracoleBundle\Factory\SectionFactoryTrait;
use Lc\CaracoleBundle\Model\Merchant\MerchantInterface;
use Lc\CaracoleBundle\Model\Product\ProductCategoryInterface;
use Lc\CaracoleBundle\Model\Section\SectionInterface;
use Lc\SovBundle\Factory\AbstractFactory;

class ProductCategoryFactory extends AbstractFactory
{
    use MerchantFactoryTrait;
    use SectionFactoryTrait;

    public function create(): ProductCategoryInterface
    {
        $productCategory = new ProductCategory();

        $productCategory->setMerchant($this->merchant);
        $productCategory->setSection($this->section);

        return $productCategory;
    }

}
