<?php

namespace Lc\CaracoleBundle\Factory\Setting;

use App\Entity\Setting\MerchantSetting;
use Lc\CaracoleBundle\Factory\MerchantFactoryTrait;
use Lc\CaracoleBundle\Model\Merchant\MerchantInterface;
use Lc\SovBundle\Factory\AbstractFactory;
use Lc\SovBundle\Model\File\FileInterface;

class MerchantSettingFactory extends AbstractFactory
{
    use MerchantFactoryTrait;

    public function create(string $name, string $text = null, \DateTime $date = null, FileInterface $file = null)
    {
        $merchantSetting = new MerchantSetting();

        $merchantSetting->setMerchant($this->merchant);
        $merchantSetting->setName($name);
        $merchantSetting->setText($text);
        $merchantSetting->setDate($date);
        $merchantSetting->setFile($file);

        return $merchantSetting;
    }
}
