<?php

namespace Lc\CaracoleBundle\Factory\Setting;

use App\Entity\Setting\SectionSetting;
use Lc\CaracoleBundle\Factory\SectionFactoryTrait;
use Lc\CaracoleBundle\Model\Section\SectionInterface;
use Lc\SovBundle\Factory\AbstractFactory;
use Lc\SovBundle\Model\File\FileInterface;

class SectionSettingFactory extends AbstractFactory
{
    use SectionFactoryTrait;

    public function create(string $name, string $text = null, \DateTime $date = null, FileInterface $file = null)
    {
        $merchantSetting = new SectionSetting();

        $merchantSetting->setSection($this->section);
        $merchantSetting->setName($name);
        $merchantSetting->setText($text);
        $merchantSetting->setDate($date);
        $merchantSetting->setFile($file);

        return $merchantSetting;
    }
}
