<?php

namespace Lc\CaracoleBundle\Model\Order;

use Doctrine\ORM\Mapping as ORM;
use Lc\CaracoleBundle\Doctrine\Extension\ReductionTrait;

/**
 * @ORM\MappedSuperclass()
 */
abstract class OrderProductReductionCatalogModel
{
    use ReductionTrait;

    /**
     * @ORM\Column(type="string", length=255)
     */
    protected $title;

    public function getTitle(): ?string
    {
        return $this->title;
    }

    public function setTitle(string $title): self
    {
        $this->title = $title;

        return $this;
    }

    // getSummaryOrderProductReductionCatalog
    public function getSummary()
    {
        $text = '';

        if ($this->getUnit() == 'amount') {
            $text .= '- ' . $this->getValue() . '&nbsp;€';
        }

        if ($this->getUnit() == 'percent') {
            $text .= '- ' . $this->getValue() . '&nbsp;%';
        }

        return $text;
    }

    // compareOrderProductReductionCatalog
    public function compare($orderProductReductionCatalog)
    {
        return $orderProductReductionCatalog
                && $this->getUnit() == $orderProductReductionCatalog->getUnit()
                && (string)$this->getValue() == (string)$orderProductReductionCatalog->getValue()
                && $this->getBehaviorTaxRate() == $orderProductReductionCatalog->getBehaviorTaxRate();
    }
}
