<?php

namespace Lc\CaracoleBundle\Repository\Section;

use Knp\Component\Pager\PaginatorInterface;
use Lc\CaracoleBundle\Repository\MerchantRepositoryQueryTrait;
use Lc\SovBundle\Repository\AbstractRepositoryQuery;

class SectionRepositoryQuery extends AbstractRepositoryQuery
{
    use MerchantRepositoryQueryTrait;

    public function __construct(SectionRepository $repository, PaginatorInterface $paginator)
    {
        parent::__construct($repository, 'r', $paginator);
    }

    public function filterByDevAlias(string $devAlias)
    {
        return $this
                ->andWhere('.devAlias LIKE :devAlias')
                ->setParameter('devAlias', $devAlias);
    }
}
