<?php

namespace Lc\CaracoleBundle\Repository\Section;

use Lc\CaracoleBundle\Model\Section\SectionInterface;
use Lc\CaracoleBundle\Repository\MerchantStoreTrait;
use Lc\CaracoleBundle\Repository\Order\OrderShopStore;
use Lc\SovBundle\Repository\AbstractStore;
use Symfony\Component\HttpKernel\Exception\NotFoundHttpException;

class SectionStore extends AbstractStore
{
    use MerchantStoreTrait;

    protected SectionRepositoryQuery $query;
    protected OrderShopStore $orderShopStore;

    public function __construct(SectionRepositoryQuery $query)
    {
        $this->query = $query;
    }

    // getSection
    public function getOneByDevAlias(string $devAlias): ?SectionInterface
    {
        $query = $this->query->create();

        $query
                ->filterByMerchant($this->merchant)
                ->filterByDevAlias($devAlias);

        $section = $query->findOne();

        if (!$section) {
            throw new NotFoundHttpException('La section ' . $devAlias . ' est introuvable');
        }

        return $section;
    }

    public function countOpenDays(SectionInterface $section): int
    {
        // @TODO : à implémenter avec le nouveau système d'ouverture des commandes
    }
}
