<?php

namespace Lc\CaracoleBundle\Repository\User;

use Lc\CaracoleBundle\Model\Merchant\MerchantInterface;
use Lc\CaracoleBundle\Model\User\UserMerchantInterface;
use Lc\CaracoleBundle\Repository\MerchantStoreTrait;
use Lc\CaracoleBundle\Solver\User\UserMerchantSolver;
use Lc\SovBundle\Model\User\UserInterface;
use Lc\SovBundle\Repository\AbstractStore;

class UserMerchantStore extends AbstractStore
{
    use MerchantStoreTrait;

    protected UserMerchantRepositoryQuery $query;
    protected UserMerchantSolver $userMerchantSolver;

    public function __construct(UserMerchantRepositoryQuery $query, UserMerchantSolver $userMerchantSolver)
    {
        $this->query = $query;
        $this->userMerchantSolver = $userMerchantSolver;
    }

    // getUserMerchant
    public function getOneByUser(UserInterface $user): UserMerchantInterface
    {
        $query = $this->query->create();

        $query
                ->filterByMerchant($this->merchant)
                ->filterByUser($user);

        return $query->findOne();
    }

    public function isCreditActiveByUser(UserInterface $user): bool
    {
        $userMerchant = $this->getOneByUser($user);
        return $this->userMerchantSolver->isCreditActive($userMerchant);
    }
}
